Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs	(revision 16240)
@@ -34,4 +34,10 @@
     public void Cleanup() {
       var pm = PersistenceManager;
+
+      pm.UseTransaction(() => {
+        FinishJobDeletion(pm);
+        pm.SubmitChanges();
+      });
+
       pm.UseTransaction(() => {
         SetTimeoutSlavesOffline(pm);
@@ -45,4 +51,13 @@
         pm.SubmitChanges();
       });
+    }
+
+    /// <summary>
+    /// Deletes all jobs which are in state "DeletionPending" (this will include all corresponding tasks).
+    /// The state "DeletionPending" is set by HiveJanitor > StatisticsGenerator
+    /// </summary>
+    private void FinishJobDeletion(IPersistenceManager pm) {
+      var jobDao = pm.JobDao;
+      jobDao.DeleteByState(JobState.DeletionPending);
     }
 
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Services.Hive/3.3/Manager/HeartbeatManager.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Services.Hive/3.3/Manager/HeartbeatManager.cs	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Services.Hive/3.3/Manager/HeartbeatManager.cs	(revision 16240)
@@ -142,61 +142,73 @@
     private IEnumerable<MessageContainer> UpdateTasks(IPersistenceManager pm, Heartbeat heartbeat, bool isAllowedToCalculate) {
       var taskDao = pm.TaskDao;
-      var assignedResourceDao = pm.AssignedResourceDao;
+      var jobDao = pm.JobDao;
+      var assignedJobResourceDao = pm.AssignedJobResourceDao;
       var actions = new List<MessageContainer>();
       if (heartbeat.JobProgress == null || !heartbeat.JobProgress.Any())
         return actions;
 
-      if (!isAllowedToCalculate && heartbeat.JobProgress.Count != 0) {
-        actions.Add(new MessageContainer(MessageContainer.MessageType.PauseAll));
-      } else {
-        // select all tasks and statelogs with one query
-        var taskIds = heartbeat.JobProgress.Select(x => x.Key).ToList();
-        var taskInfos = pm.UseTransaction(() =>
-          (from task in taskDao.GetAll()
-           where taskIds.Contains(task.TaskId)
-           let lastStateLog = task.StateLogs.OrderByDescending(x => x.DateTime).FirstOrDefault()
-           select new {
-             TaskId = task.TaskId,
-             Command = task.Command,
-             SlaveId = lastStateLog != null ? lastStateLog.SlaveId : default(Guid)
-           }).ToList()
-        );
-
-        // process the jobProgresses
-        foreach (var jobProgress in heartbeat.JobProgress) {
-          var progress = jobProgress;
-          var curTask = taskInfos.SingleOrDefault(x => x.TaskId == progress.Key);
-          if (curTask == null) {
-            actions.Add(new MessageContainer(MessageContainer.MessageType.AbortTask, progress.Key));
-            LogFactory.GetLogger(this.GetType().Namespace).Log("Task on slave " + heartbeat.SlaveId + " does not exist in DB: " + jobProgress.Key);
-          } else {
-            var slaveId = curTask.SlaveId;
-            if (slaveId == Guid.Empty || slaveId != heartbeat.SlaveId) {
-              // assigned slave does not match heartbeat
+      var jobIdsWithStatisticsPending = jobDao.GetJobIdsByState(DA.JobState.StatisticsPending).ToList();
+
+      // select all tasks and statelogs with one query
+      var taskIds = heartbeat.JobProgress.Select(x => x.Key).ToList();
+      var taskInfos = pm.UseTransaction(() =>
+        (from task in taskDao.GetAll()
+          where taskIds.Contains(task.TaskId)
+          let lastStateLog = task.StateLogs.OrderByDescending(x => x.DateTime).FirstOrDefault()
+          select new {
+            TaskId = task.TaskId,
+            JobId = task.JobId,
+            State = task.State,
+            Command = task.Command,
+            SlaveId = lastStateLog != null ? lastStateLog.SlaveId : default(Guid)
+          }).ToList()
+      );
+
+      // process the jobProgresses
+      foreach (var jobProgress in heartbeat.JobProgress) {
+        var progress = jobProgress;
+        var curTask = taskInfos.SingleOrDefault(x => x.TaskId == progress.Key);
+        if (curTask == null) {
+          actions.Add(new MessageContainer(MessageContainer.MessageType.AbortTask, progress.Key));
+          LogFactory.GetLogger(this.GetType().Namespace).Log("Task on slave " + heartbeat.SlaveId + " does not exist in DB: " + jobProgress.Key);
+        } else if (jobIdsWithStatisticsPending.Contains(curTask.JobId)) {
+          // parenting job of current task has been requested for deletion (indicated by job state "Statistics Pending")
+          // update task execution time
+          pm.UseTransaction(() => {
+            taskDao.UpdateExecutionTime(curTask.TaskId, progress.Value.TotalMilliseconds);
+          });
+          actions.Add(new MessageContainer(MessageContainer.MessageType.AbortTask, curTask.TaskId));
+          LogFactory.GetLogger(this.GetType().Namespace).Log("Abort task " + curTask.TaskId + " on slave " + heartbeat.SlaveId + ". The parenting job " + curTask.JobId + " was requested to be deleted.");
+        } else if (curTask.SlaveId == Guid.Empty || curTask.SlaveId != heartbeat.SlaveId) {
+          // assigned slave does not match heartbeat
+          actions.Add(new MessageContainer(MessageContainer.MessageType.AbortTask, curTask.TaskId));
+          LogFactory.GetLogger(this.GetType().Namespace).Log("The slave " + heartbeat.SlaveId + " is not supposed to calculate task: " + curTask.TaskId);
+        } else if (!isAllowedToCalculate) {
+          actions.Add(new MessageContainer(MessageContainer.MessageType.PauseTask, curTask.TaskId));
+          LogFactory.GetLogger(this.GetType().Namespace).Log("The slave " + heartbeat.SlaveId + " is not allowed to calculate any tasks tue to a downtime. The task is paused.");
+        } else if (!assignedJobResourceDao.CheckJobGrantedForResource(curTask.JobId, heartbeat.SlaveId)) {
+          // slaveId (and parent resourceGroupIds) are not among the assigned resources ids for task-parenting job
+          // this might happen when (a) job-resource assignment has been changed (b) slave is moved to different group
+          actions.Add(new MessageContainer(MessageContainer.MessageType.PauseTask, curTask.TaskId));
+          LogFactory.GetLogger(this.GetType().Namespace).Log("The slave " + heartbeat.SlaveId + " is not granted to calculate task: " + curTask.TaskId + " of job: " + curTask.JobId);
+        } else {
+          // update task execution time
+          pm.UseTransaction(() => {
+            taskDao.UpdateExecutionTime(curTask.TaskId, progress.Value.TotalMilliseconds);
+          });
+          switch (curTask.Command) {
+            case DA.Command.Stop:
+              actions.Add(new MessageContainer(MessageContainer.MessageType.StopTask, curTask.TaskId));
+              break;
+            case DA.Command.Pause:
+              actions.Add(new MessageContainer(MessageContainer.MessageType.PauseTask, curTask.TaskId));
+              break;
+            case DA.Command.Abort:
               actions.Add(new MessageContainer(MessageContainer.MessageType.AbortTask, curTask.TaskId));
-              LogFactory.GetLogger(this.GetType().Namespace).Log("The slave " + heartbeat.SlaveId + " is not supposed to calculate task: " + curTask.TaskId);
-            } else if (!assignedResourceDao.TaskIsAllowedToBeCalculatedBySlave(curTask.TaskId, heartbeat.SlaveId)) {
-              // assigned resources ids of task do not match with slaveId (and parent resourceGroupIds); this might happen when slave is moved to different group
-              actions.Add(new MessageContainer(MessageContainer.MessageType.PauseTask, curTask.TaskId));
-            } else {
-              // update task execution time
-              pm.UseTransaction(() => {
-                taskDao.UpdateExecutionTime(curTask.TaskId, progress.Value.TotalMilliseconds);
-              });
-              switch (curTask.Command) {
-                case DA.Command.Stop:
-                  actions.Add(new MessageContainer(MessageContainer.MessageType.StopTask, curTask.TaskId));
-                  break;
-                case DA.Command.Pause:
-                  actions.Add(new MessageContainer(MessageContainer.MessageType.PauseTask, curTask.TaskId));
-                  break;
-                case DA.Command.Abort:
-                  actions.Add(new MessageContainer(MessageContainer.MessageType.AbortTask, curTask.TaskId));
-                  break;
-              }
-            }
-          }
-        }
-      }
+              break;
+          }
+        }
+        
+      } 
       return actions;
     }
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Services.Hive/3.3/ServiceContracts/IHiveService.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Services.Hive/3.3/ServiceContracts/IHiveService.cs	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Services.Hive/3.3/ServiceContracts/IHiveService.cs	(revision 16240)
@@ -31,6 +31,7 @@
   public interface IHiveService {
     #region Task Methods
-    [OperationContract]
-    Guid AddTask(Task task, TaskData taskData, IEnumerable<Guid> resourceIds);
+
+    [OperationContract]
+    Guid AddTask(Task task, TaskData taskData);
 
     [OperationContract]
@@ -78,11 +79,23 @@
 
     [OperationContract]
-    Guid AddJob(Job jobDto);
-
-    [OperationContract]
-    void UpdateJob(Job jobDto);
-
-    [OperationContract]
-    void DeleteJob(Guid JobId);
+    IEnumerable<Job> GetJobsByProjectId(Guid projectId);
+
+    [OperationContract]
+    IEnumerable<Job> GetJobsByProjectIds(IEnumerable<Guid> projectIds);
+
+    [OperationContract]
+    Guid AddJob(Job jobDto, IEnumerable<Guid> resourceIds);
+
+    [OperationContract]
+    void UpdateJob(Job jobDto, IEnumerable<Guid> resourceIds);
+
+    [OperationContract]
+    void UpdateJobState(Guid JobId, JobState jobState);
+
+    [OperationContract]
+    void UpdateJobStates(IEnumerable<Guid> jobIds, JobState jobState);
+
+    [OperationContract]
+    IEnumerable<AssignedJobResource> GetAssignedResourcesForJob(Guid jobId);
     #endregion
 
@@ -132,13 +145,62 @@
     #endregion
 
-    #region ResourcePermission Methods
-    [OperationContract]
-    void GrantResourcePermissions(Guid resourceId, Guid[] grantedUserIds);
-
-    [OperationContract]
-    void RevokeResourcePermissions(Guid resourceId, Guid[] grantedUserIds);
-
-    [OperationContract]
-    IEnumerable<ResourcePermission> GetResourcePermissions(Guid resourceId);
+    #region Project Methods
+    [OperationContract]
+    Guid AddProject(Project projectDto);
+
+    [OperationContract]
+    void UpdateProject(Project projectDto);
+
+    [OperationContract]
+    void DeleteProject(Guid projectId);
+
+    [OperationContract]
+    Project GetProject(Guid projectId);
+
+    [OperationContract]
+    IEnumerable<Project> GetProjects();
+
+    [OperationContract]
+    IEnumerable<Project> GetProjectsForAdministration();
+
+    [OperationContract]
+    IDictionary<Guid, HashSet<Guid>> GetProjectGenealogy();
+
+    [OperationContract]
+    IDictionary<Guid, string> GetProjectNames();
+    #endregion
+
+    #region ProjectPermission Methods
+    [OperationContract]
+    void SaveProjectPermissions(Guid projectId, List<Guid> grantedUserIds, bool reassign, bool cascading, bool reassignCascading);
+
+    //[OperationContract]
+    //void GrantProjectPermissions(Guid projectId, List<Guid> grantedUserIds, bool cascading);
+
+    //[OperationContract]
+    //void RevokeProjectPermissions(Guid projectId, List<Guid> grantedUserIds, bool cascading);
+
+    [OperationContract]
+    IEnumerable<ProjectPermission> GetProjectPermissions(Guid projectId);
+    #endregion
+
+    #region AssignedProjectResource Methods
+    [OperationContract]
+    void SaveProjectResourceAssignments(Guid projectId, List<Guid> resourceIds, bool reassign, bool cascading, bool reassignCascading);
+
+    //[OperationContract]
+    //void AssignProjectResources(Guid projectId, List<Guid> resourceIds, bool cascading);
+
+    //[OperationContract]
+    //void UnassignProjectResources(Guid projectId, List<Guid> resourceIds, bool cascading);
+
+    [OperationContract]
+    IEnumerable<AssignedProjectResource> GetAssignedResourcesForProject(Guid projectId);
+
+    [OperationContract]
+    IEnumerable<AssignedProjectResource> GetAssignedResourcesForProjectAdministration(Guid projectId);
+
+    [OperationContract]
+    IEnumerable<AssignedProjectResource> GetAssignedResourcesForProjectsAdministration(IEnumerable<Guid> projectIds);
     #endregion
 
@@ -160,4 +222,16 @@
 
     [OperationContract]
+    IEnumerable<Slave> GetSlavesForAdministration();
+
+    [OperationContract]
+    IEnumerable<SlaveGroup> GetSlaveGroupsForAdministration();
+
+    [OperationContract]
+    IDictionary<Guid, HashSet<Guid>> GetResourceGenealogy();
+
+    [OperationContract]
+    IDictionary<Guid, string> GetResourceNames();
+
+    [OperationContract]
     void UpdateSlave(Slave slave);
 
@@ -207,4 +281,10 @@
     [OperationContract]
     Guid GetUserIdByUsername(string username);
+
+    [OperationContract]
+    Dictionary<Guid, HashSet<Guid>> GetUserGroupTree();
+
+    [OperationContract]
+    bool CheckAccessToAdminAreaGranted();
     #endregion
 
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Services.OKB.DataAccess/3.3/OKB.dbml	(revision 16240)
@@ -1,4 +1,4 @@
 ﻿<?xml version="1.0" encoding="utf-8"?><Database Name="HeuristicLab.OKB" EntityNamespace="HeuristicLab.Services.OKB.DataAccess" ContextNamespace="HeuristicLab.Services.OKB.DataAccess" Class="OKBDataContext" xmlns="http://schemas.microsoft.com/linqtosql/dbml/2007">
-  <Connection Mode="AppSettings" ConnectionString="Data Source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.OKB" SettingsObjectName="HeuristicLab.Services.OKB.DataAccess.Properties.Settings" SettingsPropertyName="OKBConnectionString" Provider="System.Data.SqlClient" />
+  <Connection Mode="AppSettings" ConnectionString="Data Source=localhost;Integrated Security=SSPI;Initial Catalog=HeuristicLab.OKB" SettingsObjectName="HeuristicLab.Services.OKB.DataAccess.Properties.Settings" SettingsPropertyName="OKBConnectionString" Provider="System.Data.SqlClient" />
   <Table Name="dbo.AlgorithmClass" Member="AlgorithmClasses">
     <Type Name="AlgorithmClass">
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Services.OKB.DataAccess/3.3/Properties/Settings.settings
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Services.OKB.DataAccess/3.3/Properties/Settings.settings	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Services.OKB.DataAccess/3.3/Properties/Settings.settings	(revision 16240)
@@ -6,8 +6,7 @@
       <DesignTimeValue Profile="(Default)">&lt;?xml version="1.0" encoding="utf-16"?&gt;
 &lt;SerializableConnectionString xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"&gt;
-  &lt;ConnectionString&gt;Data Source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.OKB&lt;/ConnectionString&gt;
-  &lt;ProviderName&gt;System.Data.SqlClient&lt;/ProviderName&gt;
+  &lt;ConnectionString&gt;Data Source=localhost;Integrated Security=SSPI;Initial Catalog=HeuristicLab.OKB&lt;/ConnectionString&gt;
 &lt;/SerializableConnectionString&gt;</DesignTimeValue>
-      <Value Profile="(Default)">Data Source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.OKB</Value>
+      <Value Profile="(Default)">Data Source=localhost;Integrated Security=SSPI;Initial Catalog=HeuristicLab.OKB</Value>
     </Setting>
   </Settings>
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/SpaceUsageController.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/SpaceUsageController.cs	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/SpaceUsageController.cs	(revision 16240)
@@ -36,5 +36,6 @@
     public IEnumerable<TableInformation> GetHiveTableInformation() {
       var tables = new List<string> {
-        "AssignedResources",
+        "AssignedJobResource",
+        "AssignedProjectResource",
         "Downtime",
         "Job",
@@ -43,7 +44,8 @@
         "Plugin",
         "PluginData",
+        "Project",
+        "ProjectPermission",
         "RequiredPlugins",
         "Resource",
-        "ResourcePermission",
         "StateLog",
         "Task",
@@ -65,7 +67,9 @@
         "statistics.DimClient",
         "statistics.DimJob",
+        "statistics.DimProject",
         "statistics.DimTime",
         "statistics.DimUser",
         "statistics.FactClientInfo",
+        "statistics.FactProjectInfo",
         "statistics.FactTask"
       };
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ClientController.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ClientController.cs	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ClientController.cs	(revision 16240)
@@ -74,5 +74,6 @@
                   on client.Id equals info.ClientId into clientInfoJoin
                 from clientInfo in clientInfoJoin.OrderByDescending(x => x.Time).Take(1)
-                let offline = (client.ExpirationTime != null || clientInfo.SlaveState == SlaveState.Offline)
+                let offline = (client.DateExpired != null || clientInfo.SlaveState == SlaveState.Offline)
+                let parent = client.ParentResourceId.HasValue ? dimClientDao.GetById(client.ParentResourceId.Value) : null
                 select new DT.ClientDetails {
                   Id = client.Id,
@@ -85,6 +86,6 @@
                   State = offline ? SlaveState.Offline.ToString() : clientInfo.SlaveState.ToString(),
                   LastUpdate = clientInfo.Time,
-                  GroupId = client.ResourceGroupId,
-                  GroupName = client.GroupName,
+                  GroupId = client.ParentResourceId,
+                  GroupName = parent != null ? parent.Name : null,
                   UpTime = offline ? 0 : upTime,
                   TotalUnavailableTime = timeData != null ? timeData.TotalUnavailableTime : 0,
@@ -117,5 +118,5 @@
       var factClientInfoDao = pm.FactClientInfoDao;
       return pm.UseTransaction(() => {
-        var clients = expired ? dimClientDao.GetExpiredClients() : dimClientDao.GetActiveClients();
+        var clients = expired ? dimClientDao.GetAllExpiredSlaves() : dimClientDao.GetAllOnlineSlaves();
         var query = (from client in clients
                      join info in factClientInfoDao.GetAll()
@@ -123,4 +124,5 @@
                      from clientInfo in clientInfoJoin.OrderByDescending(x => x.Time).Take(1)
                      let offline = (expired || clientInfo.SlaveState == SlaveState.Offline)
+                     let parent = client.ParentResourceId.HasValue ? dimClientDao.GetById(client.ParentResourceId.Value) : null
                      select new DT.Client {
                        Id = client.Id,
@@ -132,6 +134,6 @@
                        CpuUtilization = offline ? 0 : clientInfo.CpuUtilization,
                        State = offline ? SlaveState.Offline.ToString() : clientInfo.SlaveState.ToString(),
-                       GroupId = client.ResourceGroupId,
-                       GroupName = client.GroupName,
+                       GroupId = client.ParentResourceId,
+                       GroupName = parent != null ? parent.Name : null,
                        IsAllowedToCalculate = clientInfo.IsAllowedToCalculate
                      });
@@ -200,6 +202,6 @@
       var factClientInfoDao = pm.FactClientInfoDao;
       return pm.UseTransaction(() => {
-        var clients = expired ? dimClientDao.GetExpiredClients() : dimClientDao.GetActiveClients();
-        clients = clients.Where(x => x.ResourceGroupId == id);
+        var clients = expired ? dimClientDao.GetAllExpiredClients() : dimClientDao.GetAllOnlineClients();
+        clients = clients.Where(x => x.ParentResourceId == id);
         var query = (from client in clients
                      join info in factClientInfoDao.GetAll()
@@ -207,4 +209,5 @@
                      from clientInfo in clientInfoJoin.OrderByDescending(x => x.Time).Take(1)
                      let offline = (expired || clientInfo.SlaveState == SlaveState.Offline)
+                     let parent = client.ParentResourceId.HasValue ? dimClientDao.GetById(client.ParentResourceId.Value) : null
                      select new DT.Client {
                        Id = client.Id,
@@ -216,6 +219,6 @@
                        CpuUtilization = offline ? 0 : clientInfo.CpuUtilization,
                        State = offline ? SlaveState.Offline.ToString() : clientInfo.SlaveState.ToString(),
-                       GroupId = client.ResourceGroupId,
-                       GroupName = client.GroupName,
+                       GroupId = client.ParentResourceId,
+                       GroupName = parent != null ? parent.Name : null,
                        IsAllowedToCalculate = clientInfo.IsAllowedToCalculate
                      });
@@ -247,5 +250,5 @@
           client => client.Id,
           (fact, client) => new {
-            client.ResourceGroupId,
+            client.ParentResourceId,
             fact.Time,
             fact.CpuUtilization,
@@ -255,5 +258,5 @@
             fact.UsedMemory
           })
-        .Where(x => x.ResourceGroupId == id)
+        .Where(x => x.ParentResourceId == id)
         .ToList();
       var clientStatus = new DT.ClientStatus {
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/GroupController.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/GroupController.cs	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/GroupController.cs	(revision 16240)
@@ -42,11 +42,11 @@
         var clientTimeData = factClientInfoDao.GetAll()
           .Join(dimClientDao.GetAll(), x => x.ClientId, y => y.Id, (x, y) => new {
-            y.ResourceGroupId,
+            y.ParentResourceId,
             x.IdleTime,
             x.OfflineTime,
             x.UnavailableTime
           })
-          .Where(x => x.ResourceGroupId == id)
-          .GroupBy(x => x.ResourceGroupId)
+          .Where(x => x.ParentResourceId == id)
+          .GroupBy(x => x.ParentResourceId)
           .Select(x => new {
             TotalIdleTime = x.Sum(y => y.IdleTime),
@@ -68,12 +68,13 @@
           })
           .FirstOrDefault();
-        return (from client in dimClientDao.GetActiveClients().Where(x => x.ResourceGroupId == id)
+        return (from client in dimClientDao.GetAllOnlineSlaves().Where(x => x.ParentResourceId == id)
                 join info in factClientInfoDao.GetAll()
                   on client.Id equals info.ClientId into clientInfoJoin
                 from clientInfo in clientInfoJoin.OrderByDescending(x => x.Time).Take(1)
                 let offline = (clientInfo.SlaveState == DA.SlaveState.Offline)
+                let parent = client.ParentResourceId.HasValue ? dimClientDao.GetById(client.ParentResourceId.Value) : null
                 select new {
-                  ResourceGroupId = client.ResourceGroupId,
-                  GroupName = client.GroupName,
+                  ResourceGroupId = client.ParentResourceId,
+                  GroupName = parent != null ? parent.Name : null,
                   TotalCores = clientInfo.NumTotalCores,
                   UsedCores = offline ? 0 : clientInfo.NumUsedCores,
@@ -114,5 +115,5 @@
       var dimClientDao = pm.DimClientDao;
       var factClientInfoDao = pm.FactClientInfoDao;
-      var data = (from client in dimClientDao.GetActiveClients()
+      var data = (from client in dimClientDao.GetAllOnlineSlaves()
                   join info in factClientInfoDao.GetAll()
                     on client.Id equals info.ClientId into clientInfoJoin
@@ -120,5 +121,5 @@
                   let offline = (clientInfo.SlaveState == DA.SlaveState.Offline)
                   select new {
-                    ResourceGroupId = client.ResourceGroupId,
+                    ResourceGroupId = client.ParentResourceId,
                     TotalCores = clientInfo.NumTotalCores,
                     UsedCores = offline ? 0 : clientInfo.NumUsedCores,
@@ -137,10 +138,9 @@
                     CpuUtilization = x.Where(y => y.SlaveState != DA.SlaveState.Offline).Average(y => (double?)y.CpuUtilization) ?? 0.0
                   });
-      var query = dimClientDao.GetAll()
-        .GroupBy(x => new { x.ResourceGroupId, x.GroupName })
-        .Select(x => new {
-          Id = x.Key.ResourceGroupId ?? default(Guid),
-          Name = x.Key.GroupName
-        });
+
+      var query = dimClientDao.GetAllOnlineSlaveGroups().Select(x => new {
+        Id = x.ResourceId,
+        Name = x.Name
+      });
       return pm.UseTransaction(() => new DT.GroupPage {
         TotalGroups = query.Count(),
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Services.WebApp/3.3/HeuristicLab.Services.WebApp-3.3.csproj
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Services.WebApp/3.3/HeuristicLab.Services.WebApp-3.3.csproj	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Services.WebApp/3.3/HeuristicLab.Services.WebApp-3.3.csproj	(revision 16240)
@@ -23,4 +23,5 @@
     <SolutionDir Condition="$(SolutionDir) == '' Or $(SolutionDir) == '*Undefined*'">..\</SolutionDir>
     <RestorePackages>true</RestorePackages>
+    <UseGlobalApplicationHostFile />
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
@@ -234,5 +235,4 @@
     <Content Include="WebApp\libs\bootstrap\fonts\glyphicons-halflings-regular.woff" />
     <Content Include="WebApp\libs\bootstrap\fonts\glyphicons-halflings-regular.woff2" />
-    <Content Include="WebApp\shared\directives\scrollToTop.js" />
     <Content Include="WebApp\shared\filter\filters.js" />
     <Content Include="WebApp\shared\images\HeuristicLab-Logo.png" />
